/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

#include "ResourceLoaderAppDirMacOS.hpp"
#include "Base/Utils.hpp"
#include <unistd.h>
#include <climits>
#include <iostream>
#include <mach-o/dyld.h>
#include <stdlib.h>

namespace OpenVulkano
{
	namespace
	{
		void* HANDLE = ResourceLoader::RegisterResourceLoader(std::make_unique<ResourceLoaderAppDirMacOS>());

		std::string FindAppDir()
		{
			char pathBuffer[PATH_MAX];
			uint32_t bufferSize = sizeof(pathBuffer);

			if (_NSGetExecutablePath(pathBuffer, &bufferSize) == 0)
			{
				char resolvedPath[PATH_MAX];
				if (realpath(pathBuffer, resolvedPath) != nullptr)
				{
					std::string_view appDirPath(resolvedPath);
					appDirPath = appDirPath.substr(0, appDirPath.find_last_of('/') + 1);
					return std::string(appDirPath);
				}
			}

			std::cerr << "Failed to find real path to application!";
			return "";
		}

		const std::string& GetAppDir()
		{
			static const std::string appDirPath = FindAppDir();
			return appDirPath;
		}
	}

	std::string ResourceLoaderAppDirMacOS::GetResourcePath(const std::string& resourceName)
	{
		return GetAppDir() + resourceName;
	}

	Array<char> ResourceLoaderAppDirMacOS::GetResource(const std::string& resourceName)
	{
		return Utils::ReadFile(GetAppDir() + resourceName, true);
	}
}